CĿ
C     Name: NorMiMax                                         06/18/93 05:50pm 
C                                                                             
C     Description: Normilizing columns of real array X( MM,NN ) on scale      
C                  according to values of max & min values                    
C                  in vectors  RMax ( MM ), RMin ( MM ).                      
C                                                                             
C     Gregory Ivakhnenko  (c)                                                 
C
      subroutine  NorMiMa2 ( N, M,MM,NN, X, RMax, RMin )
      real        X( M,NN ), RMin( MM ), RMax( MM )
      real*8      AMax, AMin
      automatic

      do 20 J= 1,M
         AMax = RMax( J )
         AMin = RMin( J )
C         write (*,*) AMax,Amin
         AMax = (AMax - AMin)/2
         if( AMax .eq. 0 )  stop '   Error (NorMiMax): X(max) = X(min)'
            do 20 I= 1,N
20          X( J,I ) = (( X( J,I ) - AMin )/ AMax) - 1
      return
      end
