CĿ
C     Name: RaMinVe2                                         06-28-95 06:17pm 
C                                                                             
C     Description: Sorting of real vector V(NN) and corresponding             
C                        integer*2 vector IV(NN) in increase order.           
C                                                                             
C     Gregory Ivakhnenko (c)                                                  
C

      subroutine RaMinVe2 ( JK, N, V,IV )
      real*8     V ( N ), Vmin
      integer*2  IV( N ), Nmin             !!
      automatic

      if( JK .ne. 0 ) then                 ! JK - key of initializing
         do 10 I= 1,N
10       IV( I ) = I
      endif

      do 20 J= 1,N-1                       ! Two cycles of points sorting
         Vmin = V ( J )
         Nmin = IV( J )
         II = J
         do 30 I= J+1,N
            if( V( I ) .lt. Vmin) then
               Vmin = V ( I )              ! Catch minimum
               Nmin = IV( I )
               II = I
            endif
30          continue
         V ( II ) = V ( J )                ! Points exchange
         IV( II ) = IV( J )
         V ( J  ) = Vmin                   ! Write minimum in first numbers
20       IV( J  ) = Nmin
      return
      end
