CĿ
C     Name: CardY_2                                          02-07-95 05:25pm 
C                                                                             
C     Description: Input of data parameters from file 'Card_Name' for COMBI   
C                  (second part)                                              
C                                                                             
C     Nataly and Gregory Ivakhnenko  (c)                                      
C

      subroutine CardY_2 ( ic, Name_In, Rep_Name, Format,
     +              M,MY,N, MM,NN, Im,Iy,In, In_Card, Ni )
      integer*2     In_Card ( Ni ),
     +              In ( N ), Im ( 600 ), Iy ( 30 )
      character*12  Name_In
      character*12  Rep_Name,  Format
      automatic
C==============================================================================
C        Ni = 13                                !! MM  600, NN  N, MY  30
C        MM,NN,MY - real number of need columns (lines), founded for Im,In,Iy
C        M, N     - declared array size         !!  N < 300000
C==============================================================================
      call Rmi2 ( ic, 300,  30, Iy, MY)
      call Rmi2 ( ic, 300, 600, Im, MM )
      call Rmi2 ( ic, 300,   N, In, NN )         ! Found real value of NN

      if( M .gt. 600  .or.  MM .gt. 600  .or.  MY .gt. 30 )
     +   stop'*** Abort: Too many variables or functions used !***'

      if( Im( MM ) .gt. M .or. Iy( MY ) .gt. M .or. In( NN ) .gt. N )
     +stop'* Abort: No. of used columns or lines great than declared !*'

      if( Iy( 1 ) .eq. 0  .and.  MY .eq. 1 ) then
         Iy( 1 ) = M
         MY = 1
      endif

      read ( ic,'(A12)')  Format
      read (ic,*)

      do 40 I= 1,11                                    ! Read 9 parameters
40    read( ic,111 ) In_Card( I )
      read (ic,*)

      do 70 I= 12,15                                  ! Read 10-14 parameters
70    read( ic,111 ) In_Card( I )

      L = len_trim ( Name_In )
!	Name_In = Name_In( 1:L )						! remove blanks
	read ( ic,'(A12)' )  Rep_Name                   ! Report file name - 15
      if( len_trim( Rep_Name ) .eq. 0 ) then          !
         I = scan( Name_In, '.' )                     ! Found '.' in name
         J = scan( Name_In, '\',BACK=.TRUE.)          ! Found '\' in name
         if( I .eq. 0 )  then
            Rep_Name  = Name_In( J+1:L ) // '.RES'     ! Write extension
         else
            Rep_Name  = Name_In( J+1:I ) //  'RES'     ! Write RES in name
         endif
      endif

!      read( ic,* )
!      read( ic,111 ) In_Card( 15 )                    ! Read protection parameter

!      if( In_Card( 15 ) .ne. 0 )                      !!! JProt - no.15
!     +   read (ic,'(/,600I3)') ( IProt( I ), I= 1,MQ )! Read protection vector
                                                        !!!!!!!!! MQ = 20 !!!!!!!!
C        write (*,*) 'IProt:', ( IProt( J ), J= 1,MQ )
!      write (*,*) 'In:', ( In_Card ( J ), J= 1,13 )
                                              !!! no. for approximation only ?!!
      close( 1 )
C-----------------------------------------------------------------------------
      if( Im( 1 ) .eq. 0  .and.  MM .eq. 1 )  then    ! If in card 0 - all
         L = 0
         do 10 I= 1,M
               do 20 J= 1,MY                          ! Extract function col.
20             if( Iy( J ) .eq. I )  goto 10
            L = L + 1
            Im( L ) = I                               ! Write var.col. vector
10       continue                                     ! ne to Iy
         M  = L
         MM = M
      elseif( M .ne. 1 ) then                         ! for forecasting can be one variable
         do 30 I= 1,MM
            do 30 J= 1,MY
30          if( Iy( J ) .eq. Im( I ) )                ! Check Y=X
     +stop'* Error: No. of used functions and variables are the same !*'
      endif

      if( In( 1 ) .eq. 0  .and.  NN .eq. 1 ) then
            do 50 I= 1,N                              ! All points
50          In( I ) = I
         NN = N
      endif

      do 60 I= 1,MY                                   ! Y in Im with sign "-"
60    Im( I+MM ) = -Iy( I )

      return
111   format ( I6 )
      end
