CĿ
C     Name: DatYPIn                                          06-28-95 02:37pm 
C                                                                             
C     Description: Input part of data from file 'Name' in format 'Format'     
C                  with functions                                             
C                                                                             
C     Gregory Ivakhnenko (c)                                                  
C

      subroutine DatYPIn( Name_In, Format, M0,M0y,M,MY,N,NT,ML,MM,NN,
     +                    X,XT, Im,In,Iy )
      real            X( ML,NN ),  XT( M0y,NT ), Q( 600 )    !! MM < 600
      integer*2       In ( N ),    Im( 600 ),   Iy( 30 )    !! MY < 30
      character*12    Name_In
      character*12    Format                   ! Input file name, format

      common /LMai1/  JRes,  JFile,  JGraph,  JNorm,  JProt,  LFor,
     +                LAn,   LTest,   LSel
      automatic
C=============================================================================
C        MM,NN,MY - real number of need columns, founded from Im,In,Iy in CardIn
C        M, N     - declared array size
C=============================================================================
      open ( 1, file= Name_In, status= 'OLD', mode= 'READ', err= 9999)
         K  = 1                                    ! Point number
         KI = 0                                    ! Test point number
         do 10 I= 1,N                              ! Read string from file to Q
            read( 1, Format, ERR= 100, END= 200) ( Q( J ), J= 1,M )
                                                   ! (MQ = M current - full need size)
            if( I .eq. In( K ))  then              
               if( K .le. NN )  then
                     do 20 J= 1,M0
20                   X( J,K ) = Q( Im( J ))        ! Read selected X from Q
                  L = M0
                  do 30 J= 1,MY
                     L = L + 1
30                   X( L,K ) = Q( Iy( J ))        ! Read Y from end of Q also
			 endif

               if( K .gt. NN .or. (K == NN .and. LFor .ne. 0)) then
                  KI = KI + 1						 ! Read test & forecast points
                     do 40 J= 1,M0
40                   XT( J,KI ) = Q( Im( J ))           ! Read selected X from Q
                  L = M0
                  do 50 J= 1,MY
                     L = L + 1
50                   XT( L,KI ) = Q( Iy( J ))        ! Read Y from end of Q also
               endif
			 K = K + 1
10          endif

      close( 1 )

	NN = K - LTest - 1
!	NN = K - KI - 1

C      call MatPri ( MQ,NN, MQ,NN, X  )
C      call MatPri ( MQ,NT, MQ,NT, XT )

      M  = MM                       !! Assign real array size to no. of variables
      N  = NN
      return

100   close( 1 )
      write(*,'(/,3X,A32,I5,A20,A12,A4,/,15X,A52)')
     +  '*** Abort: Reading error at the', I, ' point in the file  ',
     +   Name_In,' ***',
     +  '*** or autodetection of number of lines failed ! ***'
      stop ' '

200   close( 1 )
      write (*,*)
      stop'*** Error: Too many lines in the data file are declared !***'
      return

9999  write(*,'(/,3X,3A)')
     +'*** Abort: Opening error of the input file: ',Name_In,'! ***'
      stop ' '
      end
