CĿ
C      Name: Init_Axe                                        06/24/92 03:00pm 
C                                                                             
C     Description: Initialize graph parameters.                               
C                                                                             
C     Gregory Ivakhnenko (c)  1992.                                           
C
         include              'FGRAPH.FI'
      integer function Init_Axe ()
         include              'FGRAPH.FD'
      integer*2            dummy,cols,rows, ICoX,ICoAxe,ICo1,ICo2,
     +                     X1,Y1,Y2,YAX,XAX, MaxRows,IWarnRow,IYnameRow
      common /LAXE/        cols,rows, X1,Y1,Y2, ICoX,ICoAxe,ICo1,ICo2,
     +                     YAX,XAX, MaxRows,IWarnRow,IYnameRow
      common /LMODE/       scr
      record /videoconfig/ scr
      record /xycoord/     xy
C==============================================================================
C        rows,cols  - text rows and columns number for current mode
C        xwidth, yheight - screen pixel number for current mode
C        Y0, X0     - origin of coordinates coordinate
C        X1, Y1     - maximal point coordinates in system of coordinates
C        Y2         - number of pixel for lifting up graphs from origin on axe Y
C        ICoX       - Xname colour
C        ICoAxe     - Yname colour
C        ICo2       - Yname2 colour
C        YAX,XAX    - axes sizes
C==============================================================================
C           Set  axes  parameters   !?  -> PARAMETERS
C -----------------------------------------------------------------------------
      xwidth  = scr.numxpixels - 1
      if( xwidth .lt. 200 ) return
      yheight = scr.numypixels - 1
      cols    = scr.numtextcols
      rows    = scr.numtextrows

C      Y0 = 35                      ! X(0)
C      X0 = 75                      ! Y(0)
      X1 = xwidth - 75 - 10         ! X range   
      Y1 = 35 + 52 - yheight        ! Y range        20
      Y2 = 10                       ! Y - Y(0) up

      if( scr.numcolors .le. 4 ) then
         ICoX   = 1                 ! Text, GrName, 0 grid colour
         ICoAxe = 8                 ! Axes, grid, Xname colour
         ICo1   = 8                 ! Yname & graph colour
         ICo2   = 1                 ! Yname2 & graph2 colour
      else
         dummy = setbkcolor( $WHITE )
         ICoX   = 8
         ICoAxe = 8
         ICo1   = 16
         ICo2   = 9
      endif

      if( rows .gt. 30)  then
         MaxRows = rows - 8          ! 43 text range     !?  ->
         IWarnRow  = 4                                   !?  ->
         IYnameRow = 3                                   !?  ->
      else
         MaxRows = rows - 5          ! 25 text range
         IWarnRow  = 0
         IYnameRow = 2
      endif
      YAX = 45 - yheight             ! Y axe range  40
      XAX = xwidth - 85              ! X axe range

      dummy = wrapon  ( $GWRAPOFF )
      call SetViewOrg ( 75, yheight-35, xy)
      Init_Axe = 1
      return
C------------------------------------------------------------------------------
C      dummy = setwindow( .TRUE., 0, 0, xwidth - 75, 20 - yheight )
C      dummy = rectangle_w( $GBORDER,0,0, xwidth-75-65, yheight-20-27)
C      dummy = setwindow( .TRUE., 0, 0, 75, 20 )
C               call moveto_w ( 0, 0, wxy )         ! Draw graph 1
C               dummy = lineto_w ( 10, 20 )
C      dummy = rectangle_w( $GBORDER,0,0, 65, 27)
C      read (*,*)                             ! Wait for ENTER key to be pressed
C      call clearscreen( $GWINDOW )
C------------------------------------------------------------------------------
      end
