CĿ
C     Name: Card_In                                          04/04/93 03:33pm 
C                                                                             
C     Description: Input of data parameters from file '_Card'.                
C                                                                             
C     Gregory Ivakhnenko (c),  1990-93.                                       
C
      subroutine     Card_In ( NVar, Name_In, Form, M,N, MM,NN, IM,IN,
     +                         Par_Card, NPar,  In_Card, Ni, Var )
      character*12   Name_In,  Card_Name
      character*10   Form
      real           Par_Card ( NPar ),      Var  ( NVar )           ! MM  100
      integer        IM( 100 ),  IN( 300 ),  In_Card( Ni )           ! NN  300
      automatic

      Card_Name = '_CARD'
      open ( 1, file = Card_Name, status='OLD', mode='READ', err=9999 )
         read (1,*)
         read (1,*)
         read (1,*)
         read (1,*)
         read (1,'(A12)') Name_In
         read (1,*)
         read(1,111) M
         read(1,111) N
         write(*,'(/,10X,A25,I3)')     'Number of variables   M =', M
         write(*,  '(10X,A25,I3)')     'Number of points      N =', N
         write(*,'(9X,A20,3X,A12,/)')  'Data  file  name  -', Name_In

         call RMI ( 1, 80, 100, IM, MM )
C            write (*,*) ( IM( J ), J= 1,MM )
             read  (1,*)
         call RMI ( 1, 80, 300, IN, NN )
C            write (*,*) ( IN( J ), J= 1,NN )
             read  (1,*)

         do 30 I = 1,NPar
30       read(1,222) Par_Card(I)
C            read  (1,222) Par_Card( I )
C30          write (*,222) Par_Card( I )

         do 40 I = 1,Ni
40       read(1,111) In_Card(I)
C           read  (1,111) In_Card( I )
C40         write (*,111) In_Card( I )

         read (1,'(A10,/)') Form
         if( NVar .gt. 1 ) read( 1,'(50F8.3)') ( Var( I ),I= 1,NVar )
      close( 1 )

      if( IM( MM ) .gt. M  .or.  IN( NN ) .gt. N )  then
         stop 'Error(CardIn): Number of selected columns MM[NN] > M[N]'
      endif

      if( IM( 1 ) .eq. 0  .and.  MM .eq. 1 ) then
         MM = M
            do 10 I= 1,M
10          IM( I ) = I
      endif

      if( IN( 1 ) .eq. 0  .and.  NN .eq. 1 ) then
          NN = N
            do 20 I= 1,N
20          IN( I ) = I
      endif
      return
9999  write(*,'(/, 10X, A65)')
     +'***** Error in the opening of the input file ',Card_Name,'*****'
      stop ' '
111   format (I5,/)
222   format (F12.7,/)
      end
