CĿ
C     Name:  Balan                                           06/15/93 01:00am 
C                                                                             
C     Description:  Evaluation of balance criterion.                          
C                                                                             
C     Gregory Ivakhnenko (c)                                                  
C

      subroutine  Balan2 ( Kl,S, X, SNor,SNorB,SNorm,SNorm2, B,C,
     +					 CO, IAn )

      real        X( ML,N )
      real*8      C( ML1,ML1 ),  B( ML1,ML1 ),       CO( ML1 ),
     +			SNor( ML1,ML1 ), SNorm( ML1,ML1 ), 
     +			SNorB( ML1,ML1 ),SNorm2( ML1,ML1 )

      integer     IAn( ML11 ), MV
      real*8      S
      common /LSize/  ML,ML0,ML1,ML11,N,LAn, MV,MV1,MV2, Qmax
      automatic
C==============================================================================
C          X - 室 ᨢ 
C        IAn - ⥪騩 ᠬ
C         AA - ᨢ ᫮ ࠢ
C       SNor - ᨢ 樥⮢ ଠ ࠢ
C         CO -   樥⮢
C         Kl - 䫠 室 -   (KHAL)
C         MV - ⥪饥 祭 ᫠ ६  ᠬ
C          S - ⠭ 祭 
C==============================================================================
C           Calculate model for first subsample A
C**********************************************************************
      S = Qmax
!      L = 0                                     ! Number of points in subsample
!      do 20 I= 1,N,2                            ! Odd points
!         L = L + 1
!         AA( MV+2,L ) = X( ML0,I )               !  write function at right col.
!         do 20 J= 1,MV                          ! Creating AA array
!20          AA( J+1,L ) = X( IAn( J ),I )       !  by current variables ansamble
!
!      call REG8 ( Kl, MV+1,MV+2, L, ML1, B,C,SNor,AA, CO )

! Calculate model for training subsample A
	forall( I=1:MV )
		SNorm( I+1,  1 ) = SNor( IAn( I )+1,   1 ) ! form first row of XtX
		SNorm( MV2,I+1 ) = SNor( ML1, Ian( I )+1 ) ! form XtY column
	end forall
	
	forall( I=1:MV )
		forall( J=1:I )
			SNorm( I+1,J+1 ) = SNor( IAn( I )+1,IAn( J )+1 ) ! form column J
		end forall
		SNorm( 1:I,I+1 ) = SNorm( I+1,1:I )					 ! copy to row I
	end forall

	call Chol ( Kl, MV1,MV2, ML1, SNorm,B,C, CO )	! estimate coefficients
      if( Kl .ne. 0 ) return         

!	! Calculate criterion for test subsample B
!      forall ( I= 1:N )								!!! at all points
!     +	VN( I ) = CO( 1 )+ sum( X( IAn(1:MV),I ) * CO(2:MV1))   ! Calculate model value

	
	S = 0.
	do I= 2,N,2										! Test subsample B !
		S = S + ( X( ML0,I ) - 
     +		CO( 1 ) - sum( X( IAn(1:MV),I ) * CO(2:MV1)) )**2
	end do
C**********************************************************************
C           Calculate model for second subsample B  and found criterion value
C**********************************************************************
!	CO = 0.
!	L  = 0                                    ! Number of points in subsample
!      do 40 I= 2,N,2                            ! Even points
!         L = L + 1
!         AA( MV+2,L ) = X( ML0,I )              !  write function at right col.
!         do 40 J= 1,MV                          ! Creating AA array
!40          AA( J+1,L ) = X( IAn( J ),I )       !  by current variables ansamble
!
!      call REG8 ( Kl, MV1,MV2, L, ML1, B,C,SNor,AA, CO )

! Calculate model for training subsample A

	forall( I=1:MV )
		SNorm2( I+1,  1 ) = SNorB( IAn( I )+1,   1 ) ! form first row of XtX
		SNorm2( MV2,I+1 ) = SNorB( ML1, Ian( I )+1 ) ! form XtY column
	end forall
	
	forall( I=1:MV )
		forall( J=1:I )
			SNorm2( I+1,J+1 ) = SNorB( IAn( I )+1,IAn( J )+1 ) ! form column J
		end forall
		SNorm2( 1:I,I+1 ) = SNorm2( I+1,1:I )					 ! copy to row I
	end forall

	call Chol ( Kl, MV1,MV2, ML1, SNorm2,B,C, CO )	! estimate coefficients
      if( Kl .ne. 0 ) return         

! Calculate criterion
!      S = 0.
!	do I= 1,N 										!!! Error at all points
!    		SS = CO( 1 )+ sum( X( IAn(1:MV),I ) * CO(2:MV1))   ! Calculate model value
!		S = S + (( VN( I ) - SS )** 2 )				! Sum of criteria ( Ya - Yb )**2
!     end do		 

	do I= 1,N,2
		S = S + ( X( ML0,I ) - 
     +		CO( 1 ) - sum( X( IAn(1:MV),I ) * CO(2:MV1)) )**2
	end do
	
      S = S / N										! Average criterion value
      return
      end