C
C         There is  Card_In, DatPIn, RMI,  MatPri, VePri    02/12/93 10:42pm
C
CĿ
C         Name: Card_In  v.2.0                              10/30/92 12:44pm  
C                                                                             
C  Description: Input of data parameters from file 'Card_Name'.               
C                                                                             
C  Gregory Ivakhnenko  (c) TIM,  1990-92.                                     
C

      subroutine     Card_In ( NVar, Name, Form, M,N, MM,NN, IM,IN,
     +                         Par_Card, NPar,  In_Card, NKL, Var )
      character*12   Name
      character*10   Form
      real           Par_Card ( NPar ),    Var( NVar )         ! MM<100, NN<300
      integer        IM( 100 ), IN( 300 ), In_Card( NKL ), M,N, MM,NN
      automatic

      open ( 1, file = '_Card', status='OLD', mode='READ', err=9999)
            read (1,*)
            read (1,*)
            read (1,*)
            read (1,*)
            read (1,'(A12)') Name
            read (1,*)
            read(1,111) M
            read(1,111) N

            call RMI ( 1, 80, 100, IM, MM )
C               write (*,*) ( IM(J), J= 1,MM )
                read (1,*)
            call RMI ( 1, 80, 300, IN, NN )
C               write (*,*) ( IN(J), J= 1,NN )
                read (1,*)

            do 30 I = 1,NPar
30          read(1,222) Par_Card(I)
C               read(1,222) Par_Card(I)
C30             write (*,222) Par_Card(I)

            do 40 I = 1,NKL
40          read(1,111) In_Card(I)
C              read(1,111) In_Card(I)
C40            write (*,111) In_Card(I)

            read (1,'(A10,/)') Form
            if( NVar .ne. 0 )  read (1,'(50F8.3)') ( Var(I), I= 1,NVar)
      close (1)
      write(*,'(/,10X,A24,I3)')     'Number of variables: M =', M
      write(*,'  (10X,A24,I3)')     'Number of points:    N =', N
      write(*,'(10X,A17,4X,A12,/)') 'Data  file  name:',  Name
      if( IM( MM ) .gt. M  .or.  IN( NN ) .gt. N ) then
         stop 'Error(CardIn): Number of selected columns MM[NN] > M[N]'
      endif

         if( IM(1) .eq. 0  .and.  MM .eq. 1 ) then
            MM = M
            do 10 I= 1,M
10          IM(I) = I
         endif
      if( IN(1) .eq. 0  .and.  NN .eq. 1 ) then
          NN = N
          do 20 I= 1,N
20        IN(I) = I
      endif
      return
9999  write(*,'(/,10X,A65)')
     +'***** Error in the opening of the input file  _CARD. *****'
      stop ' '
111   format (I5,/)
222   format (F12.7,/)
      end

CĿ
C     Name: DatPIn                                           02/13/93 10:03pm 
C                                                                             
C     Description: Input part of data from file 'Name' in format 'Form'.      
C                                                                             
C     Gregory Ivakhnenko  (c) TIM,  1993.                                     
C

      subroutine     DatPIn ( Name, Form, M,N, MM,NN, X, IM,IN )
      real           X  ( MM,NN ),  Q ( 100 )
      integer        IM ( 100 ),    IN( 300 )
      character*12   Name                          ! Input file name
      character*10   Form                          ! Input format
      common /LDAT/  JPR                           ! Initial data print key
      automatic

C      write (*,*) Form
      open ( 1, file = NAME, status = 'OLD', mode = 'READ', err = 9999)
            K = 1
            do 10 I= 1,N
               read( 1, Form ) ( Q(J), J= 1,M )    ! Read string from file to Q
C                  write (*,*)  ( Q(J), J= 1,M )
C               if( I .eq. IN(K) ) then
                     do 20 J= 1,MM
20                   X(J,K) = Q( IM(J) )           ! Read selected X from Q
10                  K = K + 1
c10             endif
      close (1)
      if( JPR .ne. 0 ) then
        if( M .ne. MM  .or.  N .ne. NN ) then
         write(*,'(/,10X,A33,I3)')'Number of accepted variables: M =',MM
         write(*,'(10X,A33,I3)')  'Number of accepted    points: N =',NN
        endif
        write (*,'(/,10X,A20)') 'Initial data array :'
        call MatPri ( MM,NN, MM,NN, X )
      endif

      M = MM                                 ! Set real array size to variables ?  ->
      N = NN
      return
9999  write(*,'(/,3A)')
     +' ****** Error in the opening of the input file ',NAME,'******'
      stop ' '
      end

CĿ
C     Name: DatQIn                                           06-28-95 02:37pm 
C                                                                             
C     Description: Input part of data from file 'Name' in format 'Format'     
C                  with functions                                             
C                                                                             
C     Gregory Ivakhnenko (c)                                                  
C

      subroutine     DatQIn ( Name, M,N, MM,NN, X,Q, Im,In )
      real           X  ( MM,NN ),  Q ( M )
      integer        Im( 600 ), In( 35000 )
      character*12   Name                     ! Input file name
      common /LDAT/  JPR                           ! Initial data print key
      automatic

C      write (*,*) Name
C=============================================================================
C        MM,NN - real number of need columns, founded from Im,In,Iy in CardIn
C        M, N     - declared array size
C=============================================================================
      if( JPR .ne. 0 )
     +open ( 2, file= 'Out_tmp', status= 'old', mode= 'write',err= 8888)
      open ( 1, file= Name, status= 'OLD', mode= 'READ', err= 9999)
         K  = 1                                    ! Point number
         do 10 I= 1,N                              ! Read string from file to Q
            read( 1, *, ERR= 100, END= 200) Q
            if( JPr .ne. 0 )  write (2,222) I,Q
                                                   ! (MQ = M current - full need size)
            if( I .eq. In( K ))  then
               if( K .le. NN )  then
                     do 20 J= 1,MM
20                   X( J,K ) = Q( Im( J ))        ! Read selected X from Q
               endif
               K = K + 1
10          endif
      close( 1 )

C      NN = K - 1
      if( JPR .ne. 0 ) then
        if( M .ne. MM  .or.  N .ne. NN ) then
         write(*,'(/,10X,A33,I5)')'Number of accepted variables: M =',MM
         write(*,'(10X,A33,I5)')  'Number of accepted    points: N =',NN
         write(2,'(/,10X,A33,I5)')'Number of accepted variables: M =',MM
         write(2,'(10X,A33,I5)')  'Number of accepted    points: N =',NN
        endif
        write (*,'(/,10X,A20)') 'Initial data array :'
        call MatPri ( MM,NN, MM,NN, X )
        open ( 3, file= 'Out', status= 'OLD', mode= 'WRITE', err= 9999)
C        write (2,*)
C        write (2,*) 'Input array  (F12.4):'
            do 30 I= 1,NN
30          write (3,333) ( X(J,I), J=1,MM )
        close( 3 )
        close( 2 )
      endif

      M  = MM                       !! Assign real array size to no. of variables
      N  = NN
      return

100   close( 1 )
      close( 2 )
      write (*,*)
      write(*,'(/,1X,A34,I5,A20,A12,A4)')
     +  '*** Warning: Error when read the', I, ' point in the file  ',
     +   Name,' ***'
      write(*,'(3X,A)')
     +'*** May be too many lines or variables are declared! ***'
      NN = K - 1
      N = NN
      M = MM
      write(*,'(/,10X,A33,I5)')'Number of accepted variables: M =',MM
      write(*,'(10X,A33,I5)')  'Number of accepted    points: N =',NN
      write (*,*)
      pause '* Press Enter to continue *'
      if( JPR .ne. 0) then
        write (*,'(/,10X,A20)') 'Initial data array :'
        call MatPri ( MM,NN, MM,NN, X )
        write (*,*)
      endif
      pause '* Press Enter to continue *'
      return

200   close( 1 )
      close( 2 )
      write (*,*)
      write (*,*)
     +'*** Warning: Too many lines or variables are declared! ***'
      NN = K - 1
      N = NN
      M = MM
      write(*,'(/,10X,A33,I5)')'Number of accepted variables: M =',MM
      write(*,'(10X,A33,I5)')  'Number of accepted    points: N =',NN
      write (*,*)
      pause '* Press Enter to continue *'
      if( JPR .ne. 0) then
        write (*,'(/,10X,A20)') 'Initial data array :'
        call MatPri ( MM,NN, MM,NN, X )
      endif
      write (*,*)
      pause '* Press Enter to continue *'
      return

9999  write(*,'(/,3X,3A)')
     +'*** Abort: Opening error of the input file: ',Name,'! ***'
      stop ' '
8888  write(*,'(/,3X,3A)')
     +'*** Abort: Opening error of the input file: Out_tmp ! ***'
      stop ' '
111   format (I5,4(F6.2),I5)
222   format (I5,2X,600(F7.2))
333   format (600(F20.14))
      end

CĿ
C     Name: RMI                                                               
C                                                                             
C     Description: Reading of numbers from non-format string.                 
C

      subroutine  RMI ( ISTREAM, NCH, NN, IX, L )
      integer     IX( NN )
      integer     I,  L, IL, NI, IS, NCH, NN
      logical     LD, LN, LS
      character*1 SI, S*240
C==============================================================================
C            NCH  - amount of characters in string to read
C            L    - amount of read numbers in vector  IX
C            IX   - vector of numbers
C            ISTR - stream number
C            S    - string
C            SI   - current character
C==============================================================================
      read( ISTREAM, '(A)' )  S( 1:80 )      ! Full string (240 characters) ?
      if( NCH .gt. 80 ) read( ISTREAM, '(A)')  S(  81:160 )
      if( NCH .gt. 160) read( ISTREAM, '(A)')  S( 161:240 )

      LD = .false.                    ! Flag of interval from - to number
      LN = .true.                     ! Number flag
      LS = .false.                    ! String flag
      L  = 0                          ! Position of current number in vector IX

      do I= 1,NCH
         SI = S( I:I )
         if( ichar( SI ) .ge. 48  .and.  ichar( SI ) .le. 57 ) then
            LS = .true.                      ! if number
            if( LN ) then                    ! Ctch the first number
               LN = .false.
               IL = I                        ! IL - First position
            end if
         else
            LN = .true.                      ! if symbol

            if( LS ) then                    ! if the first occurence
               read( S( IL:I-1 ), '(I4)') N  ! Read previous number
               LS = .false.

               if( LD ) then
                  LD = .false.               ! End of From_to number cycle
                  NI = IX( L ) + 1
                  do IS= NI,N                ! Fill the vector with numbers
                     L = L + 1
                     IX( L ) = IS
                  end do
               else
                  if( SI .eq. '-' )  LD = .true. ! Begin of from_to cycle?
                  L = L + 1
                  IX( L ) = N                   ! Store the current number
               end if
C               write (*,*) ( IX(J), J= 1,L )
            else
               if( SI .eq. '-' )  LD = .true.   ! Begin of from_to cycle?
            end if

            if( SI .eq. ';') return          ! end of reading
         end if
      end do
      end

CĿ
C         Name: MatPri                                      02/12/93 10:39pm  
C                                                                             
C  Description: Print of real array  X( MM,NN ).                              
C                                                                             
C  Nataly and Gregory Ivakhnenko  (c) TIM,  1990-93.                          
C
      subroutine  MatPri ( M,N, MM,NN, X )
      real        X ( MM,NN )
      automatic
      L = M / 8. + 1
      write (*,111)
      do 10 K= 1,L
         L1 = 8. * (K - 1) + 1
         L2 = 8. *  K
         if( L2 .gt. M ) L2 = M
         write (*,222) ( J, J= L1,L2 )
         write (*,333)
            do 20 I= 1,N
20          write(*,444) I,( X(J,I), J= L1,L2 )
         if( L .ne. 1  .and.  K .ne. L  .and.  L2 .ne. M )  then
            write (*,555)
         else
            write (*,666)
            return
         endif
10    continue
      return
111   format (1X,
     +'',
     +'')
333   format (1X,
     +'',
     +'')
555   format (1X,
     +'',
     +'')
666   format (1X,
     +'',
     +'',/)
222   format (1X, '    ', 8(I5,4X))
444   format (1X, '', I3, ' ', 8F9.4)
      end

CĿ
C        Name: VePri                                         02/12/93 10:39pm 
C                                                                             
C  Description: Print of real vector V( MM ).                                 
C                                                                             
C  Nataly and Gregory Ivakhnenko  (c) TIM,  1990-93.                          
C

      subroutine  VePri ( M,MM, V )
      real        V ( MM )
      automatic
      L = M / 8. + 1
      write (*,111)
      do 10 K= 1,L
         L1 = 8. * (K - 1) + 1
         L2 = 8. *  K
         if( L2 .gt. M ) L2 = M
         write (*,222) ( J, J= L1,L2 )
         write (*,333)
         write (*,444) ( V( J ), J= L1,L2 )
         if( L .ne. 1  .and.  K .ne. L  .and.  L2 .ne. M )  then
            write (*,555)
         else
            write (*,666)
            return
         endif
10    continue
      return
111   format (1X,
     +'',
     +'')
333   format (1X,
     +'',
     +'')
555   format (1X,
     +'',
     +'')
666   format (1X,
     +'',
     +'',/)
222   format (1X, ' ', 8(I5,4X))
444   format (1X, ' ', 8F9.4   )
      end
