CĿ
C     Name: RMI                                              05/07/93 02:11am 
C                                                                             
C     Description: Reading of numbers from non-format string     (c)  1992-93 
C
      subroutine RMI ( io, NCH, NN, IX, LL )
      integer     IX( NN )
      integer     I,  LL, IL, NI, IS, NCH, NN
      logical     LD, LN, LS
      character*1 SI, S*160
C==============================================================================
C            NCH  - amount of characters in string to read  (80)
C            LL   - discovered dimension of vector IX
C            IX   - vector of numbers
C            ISTR - stream number
C            S    - string
C            SI   - current character
C==============================================================================
      read(io,'(A)') S( 1:80 )            ! Full string (240 characters) ?
      if( NCH .gt. 80 ) read(io,'(A)') S(  81:160 )
C      if( NCH .gt. 160) read(io,'(A)') S( 161:240 )

      LD = .false.                    ! Flag of interval from - to number
      LN = .true.                     ! Number flag
      LS = .false.                    ! String flag
      LL = 0                          ! Position of current number in vector IX

      do I= 1,NCH
         SI = S( I:I )
         if( ichar( SI ) .ge. 48  .and.  ichar( SI ) .le. 57 ) then
            LS = .true.                  ! if number
            if( LN ) then                       ! Ctch the first number
               LN = .false.
               IL = I                           ! IL - First position
            end if
         else
            LN = .true.                  ! if symbol

            if( LS ) then                ! if the first occurence
               read( S( IL : I-1 ), '(I4)') K   ! Read previous number
               LS = .false.

               if( LD ) then
                  LD = .false.                  ! End of From_to number cycle
                  NI = IX( LL ) + 1
                  do IS= NI,K                   ! Fill the vector with numbers
                     LL = LL + 1
                     IX( LL ) = IS
                  end do
               else
                  if( SI .eq. '-' ) LD = .true. ! Begin of from_to cycle?
                  LL = LL + 1
                  IX( LL ) = K                  ! Store the current number
               end if
C               write (*,*) ( IX( J ), J= 1,LL )
            else
               if( SI .eq. '-' )  LD = .true.   ! Begin of from_to cycle?
            end if

            if( SI .eq. ';') return             ! end of reading if ';'
            if( SI .eq. ' ') then
               if( S( I+1:I+2 ) .eq. '  ' )  return   ! end of reading if '   '
            endif
         end if
      end do
      end
