CĿ
C     Name: Khal                                             03/10/94 06:17pm 
C                                                                             
C     Description: Solving linear matrix of equations by method of Khaletskij.
C                                                                             
C     Gregory Ivakhnenko (c)                                                  
C

      subroutine  Khal ( Kl, M,M1, MM1, SNor,B,C, CO )
      real        SNor( MM1,MM1 ), C( MM1,MM1 ), B( MM1,MM1 ), CO( MM1 )
      real*8      S
C      common /LDat/  JPr                          !!
      automatic   S,L,K,J,I
      automatic
C==============================================================================
C        SNor  - 室 ᨢ
C        CO    - 室 
C        MM1   - ᨬ ࠧ ᨢ
C        JCoef -   ⠭ 樥⮢
C        JReg  -   ᮮ饭
C        Kl    - 䫠 室 -  
C         :   M1 > 3,   M = M1 - 1,  M - ᫮ ப  ᨢ
C==============================================================================
      Kl = 0
C      if( M1 .lt. 3 )  stop 'Abort (Khal): No. of variables M1 < 3 !'
      do 10 J= 1,M1
         do 10 I= J,M
10       B( J,I ) = 0.                          ! Initialize B,C
      do 20 I= 1,M
         B( 1,I ) = SNor( 1,I )
         C( I,I ) = 1.
20       C( I,1 ) = SNor( I,1 ) / SNor( 1,1 )
      C( M1,1 )  = SNor( M1,1 ) / SNor( 1,1 )
C --------------------------------------------------------------------------
      do 30 L= 2,M                              ! Main time loop
         do 40 K= L,M
         S = 0.
            do 50 J= 1,L
50          S = S + B( J,K ) * C( L,J )
40       B( L,K ) = SNor( L,K ) - S
               if( B( L,L ) .eq. 0. ) then
C                    write (*,*) ' Abort (Khal):  System not solved !'
                     do 100 J= 1,M1
100                  CO( J ) = 0.
                  Kl = 1
                  return
               endif
         do 30 K= L+1,M1
            S = 0.
               do 70 J= 1,L-1
70             S = S + B( J,L ) * C( K,J )
30          C( K,L ) = ( SNor( K,L ) - S )/ B( L,L )     !  C
         call MatPri ( M1,M, MM1,MM1, C )
C-----------------------------------------------------------------------------
      CO( M1 ) = C( M1,M )
      do 80 I= M1,2,-1
         S = 0.
            do 90 J= I,M
90          S = S + C( J,I-1 ) * CO( J )
80       CO( I-1 ) = C( M1,I-1 ) - S

C      if( JPr .ge. 4 )  write (*,111) ( CO( J ), J= 1,M )
      return
C111   format (/,' Coefficients:  ',100E12.5 )
      end
