CĿ
C     Name: NorMiMax                                         06/18/93 05:50pm 
C                                                                             
C     Description: Normilizing columns of real array X( MM,NN ) on scale      
C                  and saving of max & min columns values                     
C                  in vectors  RMax ( MM ), RMin ( MM ).                      
C                                                                             
C     Gregory Ivakhnenko  (c)                                                 
C
      subroutine  NorMiMax ( M,N, MM,NN, X, RMax, RMin )
      real        X( MM,NN ), RMin( MM ), RMax( MM )
      real*8      AMax, AMin
      automatic

      do 20 J= 1,M
         AMin = X( J,1 )
         AMax = X( J,1 )
         do 10 I= 1,N
            if( X( J,I ) .lt. AMin)  AMin = X( J,I )
10          if( X( J,I ) .gt. AMax)  AMax = X( J,I )
         RMax( J ) = AMax
         RMin( J ) = AMin
C         write (*,*) AMax,Amin
         AMax = (AMax - AMin)/ 2
         if( AMax .eq. 0 )  stop '   Error (NorMiMax): X(max) = X(min)'
            do 20 I= 1,N
20          X( J,I ) = (( X( J,I ) - AMin ) / AMax) - 1
      return
      end
