CĿ
C     : XPKLx2                                            03/29/93 00:57am 
C                                                                             
C     ᠭ: ⮣쭮 ஥஢  ⮤ 㭥-         
C               ᨢ  X( MM,NN )  ᪮.                             
C                                                                             
C     ..窮᪨ (c)  1980-1993.                                         
C

      subroutine  XPKLx2 ( M,N, MM,NN, X,XS,XD,XTX,TXT,AL, YY,Z )
      real        X  ( MM,NN ),
     +            XS ( MM ),     XD( MM ),
     +            YY ( 2, NN ),  Z  ( MM,2 )
      real*8      XTX( MM,MM ),  TXT( MM,MM ),  AL( MM )
      real*8      A, B, S
      common /LXPKL/ JXPri
C=============================================================================
C       M( MM )    - ⢮ 쥪⮢
C       N( NN )    - ⢮ ਧ
C       X( MM,NN ) -  쥪⮢,   ந  ⠭⮢
C       XS( MM ), XD( MM ) -  業஢  ନ஢
C       XTX( MM,MM ), TXT( MM,MM ), AL( MM )  - tmp
C       YY( 2,NN ) - ,  ஬  ࠭ ஥樨 쥪⮢,
C                      뫠 ஥  ⠭⮢
C       Z( MM,2 )  - , ਭ騩  ⠭⮢
C=============================================================================
C       ᫥  । XS,  ࠧ XD;
C       ஢  ନ஢  X  XP
C --------------------------------------------------------------------------
      do 20 J= 1,M
        S = 0.
        Z( J,1 ) =  1.E+16
        Z( J,2 ) = -1.E+16
        do 10 K= 1,N
           if( X( J,K ) .lt. Z( J,1 ))  Z( J,1 ) = X( J,K )    ! Found min X
           if( X( J,K ) .gt. Z( J,2 ))  Z( J,2 ) = X( J,K )    ! Found max X
10         S = S + X( J,K )

        if( Z( J,2 ) .ne. Z( J,1 )) then
           XD( J ) = Z( J,2 ) - Z( J,1 )
        else
           XD( J ) = 1.
        endif
20      XS( J ) = S / N                            ! Average value

      do 40 J= 1,M
        do 40 K= 1,N
40      X( J,K ) = ( X( J,K ) - XS( J ))/ XD( J )  ! Normilizing X
C --------------------------------------------------------------------------
C       ᫥  XTX
C --------------------------------------------------------------------------
      do 70 I = 1,M
         do 70 J = I,M
         S = 0.
            do 60 K = 1,N
60          S = S + X( I,K ) * X( J,K )
         XTX( I,J ) = S
70       if( I .ne. J )  XTX( J,I ) = S            ! Write XTX
C --------------------------------------------------------------------------
C       ᫥  Z ⮤ אַ 樨
C --------------------------------------------------------------------------
      do 80  L= 1,2                                ! L= 1,2 cycle
            do 90 J = 1,M
90          Z( J,L ) = 1.                          ! Initialize Z
         A = 1.
C-----------------------------------------------------------------------------
100      continue
         do 120 J = 1,M
            S = 0.
               do 110 I = 1,M
110            S = S + XTX( J,I ) * Z( I,L )
120         AL( J ) = S

         B = 0.
            do 130 J = 1,M
130         B = B + AL( J )**2

C         if( B .gt. 1.E-10 ) goto 150
C            do 140 I = 1,M
C140         Z( I,L ) = float( (-1) * I )
C            goto 100
C150      continue

         B = sqrt( B )
         do 160 J = 1,M
            if( B .eq. 0.) then
               Z( J,L ) = 1.E-16
               goto 170
            endif
160         Z( J,L ) = AL( J )/ B

170      continue

         if( JXPri .ne. 0 ) write (*,66) A-B
         if( abs( A-B ) .ge. 1.E-16 )  then     ! Main
           A = B
           goto 100
         endif
C -----------------------------------------------------------------------------
C           ⮢  ஥஢   
C -----------------------------------------------------------------------------
         if( L .eq. 1 ) then
            do 190 I= 1,M
              do 190 J= I,M
190           TXT( I,J ) = XTX( I,J ) - A * Z( I,L ) * Z( J,L )

            do 200 I= 1,M
              do 200 J= I,M
                 XTX( I,J ) = TXT( I,J )
200              if( I .ne. J )  XTX( J,I ) = TXT( I,J )
         endif

80    continue
C --------------------------------------------------------------------------
C          ஥஢ -ப  X  XP   ⠭⮢
C --------------------------------------------------------------------------
      do 230 L= 1,2
         do 230 I= 1,N
            A = 0.
               do 220 J= 1,M
220            A = A + X( J,I ) * Z( J,L )
230         YY( L,I ) = A
C --------------------------------------------------------------------------
C           ⠭ 室 
C --------------------------------------------------------------------------
      do 250 J= 1,M
         do 250 K= 1,N
250      X( J,K ) = X( J,K ) * XD( J ) + XS( J )
C --------------------------------------------------------------------------
C           뢮   १⮢
C --------------------------------------------------------------------------
      if( JXPRI .ne. 0 )  then
         write (*,*)
         write (*,33)  N, NN
         write (*,44)  M, MM
         write (*,11)
         do 280 L= 1,2
            A = 0.
               do 270 J= 1,M
270            A = A + ( Z( J,L ))**2
280         write (*,111) L, A

         A = 0.
            do 290 J= 1,M
290         A = A + YY( 1,J ) * YY( 2,J )
         A = 1. - A
         write (*,222) A

         do 310 L= 1,2
            write (*,55) L
310         write (*,333) ( Z( J,L ),J = 1,M )
      endif

      write (*,444)
      call MatPri ( 2,N, 2,NN, YY )

C         write (*,555)
C         NS = 1 + ( M - 1 )/ 9
C         do 330 KS =1,NS
C            write (*,666)
C            KE = 9 * KS
C            KB = KE - 8
C            if( M .lt. KE )  KE = M
C            write (*,777) ( K, K= KB,KE )
C            write (*,77)
C            do 320 I = 1, N
C               write (*,888) I, ( X( K,I ), K= KB,KE )
C               write (*,999) YY( 1,I ), YY( 2,I )
C320         continue
C330      continue
C         write (*,555)
      return
11    format(/,80('*'),/)
33    format(10X,'N ( NN ) - ⢮ ꥪ⮢  =',I4,3X,'(',I3,' )')
44    format(10X,'M ( MM ) - ⢮ ਧ =',I4,3X,'(',I3,' )')
55    format(/,5X,'न 筮 , ਭ饣 ',
     *I3,' - ')
111   format( 1X,'㬬 ⮢ न  ਭ饣 ',I3,
     *'-     =',F8.5)
222   format( 1X,'㬬 ᪠ ந न  ',
     *'  ᥩ =',F8.5)
333   format( 12F7.3 )
555   format( 1X,79(''))
666   format( 1X,'',22X,' ਧ',21X,
     *'     ஥      ')
777   format( 1X,'',3X,8I6,8X,'_________________')
77    format( 1X,'', 57X,'  1     2   ',/,1X,79(''))
888   format( 1X,'', I3, '',8F6.3,5X,'',  9X,'',  9X,'')
999   format( 1X,'', 3X, '',     53X,'',F9.5,'',F9.5,'')
444   format(/,10X,'⮣ ஥樨')
66    format ('     A-B =',E10.3)
      end
